(defun isetup ()
       (setq g:scale (getint "\n Scale = "))
       (setq tht (* 0.0016 g:scale))
       (setq thtp (/ tht 2))
       (setq tbrg 90)
       (setq dt 2)
       (setq tre 1)
       (command "units" "" "" "" "" "90" "y")
       (command "style" "txt" "" tht "" "" "" "" "")
       (command "osnap" "none")
       (graphscr)
)

(defun readfile()
   (setq pc (atoi (substr oline 44 6)))
   (setq pno(atoi (substr oline 1 6)))
   (setq eo (atof (substr oline 8 12)))
   (setq no (atof (substr oline 21 12)))
   (setq rlo (atof (substr oline 34 8)))
   (setq tre (atoi (substr oline 76 2)))
   (if (= tre 0)
    (progn
    (setq tre 1)
    )
   )
   (setq acb (substr oline 63 2))
)

(defun c:drawtree ()
   (if (null g:scale)(isetup))
   (openF)
   (setq oline (read-line fne))
   (while (not (null oline))
      (readfile)
      (setq p1 (list eo no rlo))
      (command "layer" "m" "XYZ" "c" "7" "" "")
      (command "point" p1 "")
      (drawtxt)
      (if (= lpcode pc)
       (progn
         (if (and (< pc 80)(/= 0 pc)
             (or (/= pc 20))
             (or (/= pc 30))
             (or (/= pc 40))
             (or (/= pc 50))
             (or (/= pc 60))
             (or (/= pc 70)))
            (progn
             (command "layer" "m" pc "c" pc "" "")
             (command "line" lp p1 "")
            )
         )
       )
      )
       (setq lp p1) (setq lpcode pc)
       (setq oline (read-line fne))
  )
  (close fne)
  (command "zoom" "e" "")
)

(defun drawtxt()
    (command "layer" "m" "XH" "")
    (if (< rlo 0)
      (progn
      (setq rlo (abs rlo))
      (setq mu T)
      )
      (setq mu nil)
  )
  (setq fl (itoa (fix rlo)))
  (setq rl (itoa (fix (+ (* (- rlo (fix rlo)) (expt 10 dt)) 0.5))))
  (setq r (strlen rl))
  (if (< dt r)
      (progn
      (setq wt 1) (setq rl "0")
      (while (> dt wt)
             (setq rl (strcat "0" rl))
             (setq wt (+ wt 1))
      )
      (setq fl (itoa (+ (fix rlo) 1)))
      )
  )
  (while (< r dt)
         (setq rl (strcat "0" rl))
         (setq r (strlen rl))
  )
  (setq f (strlen fl))
  (setq g 1) (setq dl 0)
  (while (<= g f)
         (if (= (substr fl g 1) "1")
             (setq dl (+ dl (* 0.666 tht)))
             (if (= (substr fl g 1) "0")
                 (setq dl (+ dl (* 0.833 tht)))
             (setq dl (+ dl tht))
             )
          )
          (setq g (1+ g))
  )
  (setq dl (+ dl (* 0.35 tht))) (setq db (+ 180 tbrg))
  (if (= mu T)
      (progn
      (setq dl (+ dl (* 0.866 tht)))
      (setq fl (strcat "-" fl))
      )
  )
  (pr dl db)
  (setq g 1) (SETQ DR 0)
  (while (<= g r)
         (if (= (substr rl g 1) "1")
             (setq dr (+ dr (* 0.666 tht)))
             (if (= (substr rl g 1) "0")
                 (setq dr (+ dr (* 0.833 tht)))
                 (setq dr (+ dr tht))
             )
         )
          (setq g (1+ g))
  )
  (setq dr (+ dr (* 0.65 tht)))
  (setq p (strcat (strcat fl " ") rl))
  (command "style" "txt" "" tht "" "" "" "" "")
   
  (command "text" "j" "c" p1 tbrg p)
  (command "layer" "m" "PNO" "c" "6" "" "")
  (command "style" "txt" "" thtp "" "" "" "" "")
  
  (command "text" "j" "tr" p1 tbrg pno)
  (if (/= acb "  ")
   (progn
    (command "layer" "m" "FEATURE" "")
    (setq ab (strcat acb ".dwg"))
    (command "insert" ab p1 tre "" "")
    (setq acb "  ")
   )
  )
)

(defun dtr (a)
  (* pi (/ a 180.0))
)
(defun pr (a b)
       (setq b (dtr b))
       (setq rdn (* a (cos b)))
       (setq rde (* a (sin b)))
)

(defun c:drawxy ()
   (if (null g:scale)(isetup))
   (openF)
   (setq oline (read-line fne))
   (while (not (null oline))
      (readfile)
      (setq p1 (list eo no rlo))
      (command "layer" "m" "XYZ" "c" "7" "" "")
      (command "point" p1 "")
      (drawxytxt)
       (setq lp p1) (setq lpcode pc)
       (setq oline (read-line fne))
  )
   (close fne)
)

(defun drawxytxt()
  (command "layer" "m" "XH" "")
    (if (< rlo 0)
      (progn
      (setq rlo (abs rlo))
      (setq mu T)
      )
      (setq mu nil)
    )
  (setq fl (itoa (fix rlo)))
  (setq rl (itoa (fix (+ (* (- rlo (fix rlo)) (expt 10 dt)) 0.5))))
  (setq r (strlen rl))
  (if (< dt r)
      (progn
      (setq wt 1) (setq rl "0")
      (while (> dt wt)
             (setq rl (strcat "0" rl))
             (setq wt (+ wt 1))
      )
      (setq fl (itoa (+ (fix rlo) 1)))
      )
  )
  (while (< r dt)
         (setq rl (strcat "0" rl))
         (setq r (strlen rl))
  )
  (setq f (strlen fl))
  (setq g 1) (setq dl 0)
  (while (<= g f)
         (if (= (substr fl g 1) "1")
             (setq dl (+ dl (* 0.666 tht)))
             (if (= (substr fl g 1) "0")
                 (setq dl (+ dl (* 0.833 tht)))
             (setq dl (+ dl tht))
             )
          )
          (setq g (1+ g))
  )
  (setq dl (+ dl (* 0.35 tht))) (setq db (+ 180 tbrg))
  (if (= mu T)
      (progn
      (setq dl (+ dl (* 0.866 tht)))
      (setq fl (strcat "-" fl))
      )
  )
  (pr dl db)
  (setq g 1) (SETQ DR 0)
  (while (<= g r)
         (if (= (substr rl g 1) "1")
             (setq dr (+ dr (* 0.666 tht)))
             (if (= (substr rl g 1) "0")
                 (setq dr (+ dr (* 0.833 tht)))
                 (setq dr (+ dr tht))
             )
         )
          (setq g (1+ g))
  )
  (setq dr (+ dr (* 0.65 tht)))
  (setq p (strcat (strcat fl " ") rl))
  (command "text" "j" "c" p1 tbrg p)
)

(defun openF()
   (setq fn (getstring "\n xyz file ="))
   (setq fn (strcat fn ".xyz"))
   (cond ((null (setq fne (open fn "r"))) ; try to open in for reading
          (princ "Can't open ")           ; if nil print error message
          (princ fn) 
          (princ " for reading.")
          )
    (setq fne (open fn "r"))  
   )
 )

(defun closeF()
   (close fne)
 )
   
(defun rdfile()
   (setq nu (atoi (substr oline 1 5)))
   (setq eo (atof (substr oline 8 12)))
   (setq no (atof (substr oline 21 12)))
 )

(defun c:FP ()
  (setq fne (open fn "r"))
  (setq Fno (getint "\n Find Point No.= "))
    (While (/= nu Fno) 
        (setq oline (read-line fne))
        (rdfile)
     )
        (close fne)
        (setq p1 (list eo no))
        (command "zoom" "c" p1 "")
 )


(DEFUN C:addnum()
	(setq num (getreal "\nStart number ?:"))
	(setq txht (getreal "\nText size ?:"))
	(setq txbrg (getreal "\nText angle ?:"))
        (command "style" "txt" "" txht "" "" "" "" "")
        (command "osnap" "none")
        (SETQ pt (GETPOINT "\n Num Location ?: "))
  (WHILE (/= pt nil)
    (setq fl (itoa (fix num)))
    (setq p (strcat fl))
    (command "text" pt txbrg p "")
    (SETQ num (+ 1 num))
    (SETQ pt (GETPOINT "\n Num Location ?: "))
  )
  (command "style" "txt" "" tht "" "" "" "" "")
 )
;;EOF
;;----------------------------------------------------------------------------



