(defun isetup ()
       (setq g:scale (getint "\n Scale = "))
       (setq tht (* 0.0008 g:scale))
       (setq tbrg 90)
       (setq dt 2)
       (command "units" "" "" "" "" "90" "y")
       (command "style" "txt" "" tht "" "" "" "" "")
       (command "osnap" "none")
       (graphscr)
)

(defun readfile()
   (setq pc (atoi (substr oline 44 6)))
   (setq pno(atoi (substr oline 1 6)))
   (setq eo (atof (substr oline 8 12)))
   (setq no (atof (substr oline 21 12)))
   (setq rlo (atof (substr oline 34 8)))
   (setq acb (substr oline 63 4))
   )
(defun c:drawxyz ()
   (if (null g:scale)(isetup))
   (setq fn (getstring "\n xyz file ="))
   (setq fn (strcat fn ".xyz"))
   (setq fne (open fn "r"))
   (setq oline (read-line fne))
   (while (not (null oline))
      (readfile)
      (setq p1 (list eo no rlo))
      (command "layer" "m" "XYZ" "c" "7" "" "")
      (command "point" p1 "")
      (drawtxt)
      ;;(if (= lpcode pc)(command "line" lp p1 ""))
      (if (= lpcode pc)
       (progn
         (if (/= 0 pc)
            (progn
             (command "layer" "m" pc "c" pc "" "")
             (command "line" lp p1 "")
            )
         )
       )
      )
       (setq lp p1) (setq lpcode pc)
       (setq oline (read-line fne))
  )
   (close fne)
)

(defun drawtxt()
    (command "layer" "m" "XH" "")
    (if (< rlo 0)
      (progn
      (setq rlo (abs rlo))
      (setq mu T)
      )
      (setq mu nil)
  )
  (setq fl (itoa (fix rlo)))
  (setq rl (itoa (fix (+ (* (- rlo (fix rlo)) (expt 10 dt)) 0.5))))
  (setq r (strlen rl))
  (if (< dt r)
      (progn
      (setq wt 1) (setq rl "0")
      (while (> dt wt)
             (setq rl (strcat "0" rl))
             (setq wt (+ wt 1))
      )
      (setq fl (itoa (+ (fix rlo) 1)))
      )
  )
  (while (< r dt)
         (setq rl (strcat "0" rl))
         (setq r (strlen rl))
  )
  (setq f (strlen fl))
  (setq g 1) (setq dl 0)
  (while (<= g f)
         (if (= (substr fl g 1) "1")
             (setq dl (+ dl (* 0.666 tht)))
             (if (= (substr fl g 1) "0")
                 (setq dl (+ dl (* 0.833 tht)))
             (setq dl (+ dl tht))
             )
          )
          (setq g (1+ g))
  )
  (setq dl (+ dl (* 0.35 tht))) (setq db (+ 180 tbrg))
  (if (= mu T)
      (progn
      (setq dl (+ dl (* 0.866 tht)))
      (setq fl (strcat "-" fl))
      )
  )
  (pr dl db)
  (setq pnt1 (list (+ (car p1) rde) (+ (cadr p1) rdn)))
  (setq g 1) (SETQ DR 0)
  (while (<= g r)
         (if (= (substr rl g 1) "1")
             (setq dr (+ dr (* 0.666 tht)))
             (if (= (substr rl g 1) "0")
                 (setq dr (+ dr (* 0.833 tht)))
                 (setq dr (+ dr tht))
             )
         )
          (setq g (1+ g))
  )
  (setq dr (+ dr (* 0.65 tht)))
  (setq p (strcat (strcat fl " ") rl))
  (command "text" pnt1 tbrg p)
  (command "layer" "m" "PNO" "c" "6" "" "")
  ;;(command "layer" "s" "PNO" "")
  (command "text" "j" "tr" p1 tbrg pno)
  (if acb
   (progn
    (command "layer" "m" "FEATURE" "")
    (command "text" "j" "br" p1 tbrg acb)
   )
  )
)

(defun dtr (a)
  (* pi (/ a 180.0))
)
(defun pr (a b)
       (setq b (dtr b))
       (setq rdn (* a (cos b)))
       (setq rde (* a (sin b)))
)

